//
//  APRateUs.m
//  Apptics
//
//  Created by Prakash R on 12/10/20.
//

#import <Foundation/Foundation.h>
#import "APRateUs.h"
#import "APStoreReviewManager.h"
#if __has_include(<Apptics/Apptics.h>)
#import <Apptics/AppticsConfig.h>
#endif

@implementation APRateUs


#pragma mark - Rate Us


+(APRateUs* _Nonnull)listener
{
    static APRateUs *listener = nil;
    
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^
                  {
        listener = [[APRateUs alloc]init];
        [[NSNotificationCenter defaultCenter] addObserver:listener selector:@selector(appticsDidFinishLoad:) name:@"AppticsDidFinishLoad" object:nil];

    });
    return listener;
}

- (void) appticsDidFinishLoad : (NSNotification*) notification{
    [APRateUs enable:AppticsConfig.defaultConfig.enableRateUs];
}

#if !TARGET_OS_WATCH
+ (void) enable:(BOOL)status
{
    [[APStoreReviewManager getInstance] enableRateUsAndReview:status];
}

//+(void) staticStoreReviewPrompt;
//{
//    [[APStoreReviewManager getInstance] staticStoreReviewPrompt];
//}

+(void) showCustomReviewPrompt;
{
    [[APStoreReviewManager getInstance] showCustomReviewPrompt];
}

+(void) takeToFeedbackScreen{
    [[APStoreReviewManager getInstance] takeToFeedbackScreen];
}

+ (void) updateActionForFeedback;{
    [[APStoreReviewManager getInstance] updateActionForFeedback];
}

+ (void) takeToAppStoreReviewScreen{
    [[APStoreReviewManager getInstance] takeToAppStoreReviewScreen];
}

+ (void) updateActionForAppStoreReview;{
    [[APStoreReviewManager getInstance] updateActionForAppStoreReview];
}

+(void) checkForRatingPop;{
    [[APStoreReviewManager getInstance] checkForRatingPop];
}

+(void) showStoreAlertOnFulFillingCriteria : (bool) status;{
    [[APStoreReviewManager getInstance] showStoreAlertOnFulFillingCriteria:status];
}

+(void) setAppRatingShown;{
    [[APStoreReviewManager getInstance] setAppRatingShown];
}

+(void) storeReviewMasterReset{
    [[APStoreReviewManager getInstance] storeReviewMasterReset];
}

+(void) updateAppRatingShownForCurrentVersion;{
    [[APStoreReviewManager getInstance] setAppRatingShown];
}

+ (void) shouldPauseRateUsAndReview : (BOOL) status;
{
    [[APStoreReviewManager getInstance] setShouldPauseRateUsAndReview:status];
}

//+(void) za_rateUsOnStore;
//{
//    [[APStoreReviewManager getInstance] staticStoreReviewPrompt];
//}

#endif

@end
