//
//  JAStoreReviewManager.h
//  JAnalytics
//
//  Created by Saravanan S on 17/01/18.
//  Copyright © 2018 zoho. All rights reserved.
//

#import <Foundation/Foundation.h>
#if !TARGET_OS_WATCH
#import <StoreKit/StoreKit.h>
#endif
#if __has_include(<Apptics/Apptics.h>)
#import <Apptics/ZAEnums.h>
#import <Apptics/APEventsEnum.h>
#endif
NS_ASSUME_NONNULL_BEGIN
@interface APStoreReviewManager : NSObject

#if OS_OBJECT_HAVE_OBJC_SUPPORT == 1
@property (nonatomic, strong) dispatch_queue_t zaSerialQueue;
#else
@property (nonatomic, assign) dispatch_queue_t zaSerialQueue;
#endif

@property (nonatomic) bool enableRateUsAndReview;
@property (nonatomic) bool shouldPauseRateUsAndReview;
@property (nonatomic) bool showStoreAlertOnFulFillingCriteria;

@property (nonatomic, strong) NSNumber * criteriaId;
@property (nonatomic, strong) NSNumber * gNumberOfAttempts;

+(APStoreReviewManager*_Nonnull) getInstance;

-(void) saveAggrigatedEngagementsData;
    
-(void) loadRuleBook;

-(void) incrementAppRuns;

-(void) incrementSessionHitCount : (NSInteger) sessionDuration;

-(void) incrementEventHitCountForEventId : (NSString*_Nonnull) eventId;

-(void) incrementEventHitCount : (NSString*_Nonnull) name;

-(void) incrementScreenHitCount : (NSString*_Nonnull) name;

-(void) storeReviewMasterReset;

-(void) enableRateUsAndReview:(BOOL)status;

-(void) setAppRatingShown;

-(void) showAppStoreReviewPrompt;

-(void) showCustomReviewPrompt;

-(void) takeToAppStoreReviewScreen;

-(void) updateActionForAppStoreReview;

-(void) takeToFeedbackScreen;

-(void) updateActionForFeedback;

-(void) getAppStoreReviewUrl:(void (^_Nonnull)(NSURL * _Nullable storeReviewUrl))completionHandler;

-(void) checkForRatingPop;

-(void) showStoreAlertOnFulFillingCriteria : (bool) status;

-(void) updateRateUAction: (JRateUsAction) action type : (JRateUsType) type source : (JRateUsSource) source;

@end

NS_ASSUME_NONNULL_END
