//
//  APCustomHandler.m
//  JAnalytics
//
//  Created by Saravanan S on 26/07/18.
//  Copyright © 2018 zoho. All rights reserved.
//

#import "ARCustomHandler.h"

#import "APRateUs.h"

@implementation ARCustomHandlerManager

static ARCustomHandlerManager* sharedHandler = nil;

static dispatch_once_t onceHandlerToken;

+(ARCustomHandlerManager*)sharedHandlerManager;{
  dispatch_once(&onceHandlerToken, ^{
    
    if (sharedHandler == nil) {
      sharedHandler = [[ARCustomHandlerManager alloc] init];
    }
    
  });
  return sharedHandler;
}

+(void) setCustomHandler:(id <ARCustomHandler>) handler;{
  [ARCustomHandlerManager sharedHandlerManager].sharedCustomHandler = handler;
}

+(void) cancelledReviewPrompt:(void (^)(void))dispatchBlock ;
{
  if (sharedHandler.sharedCustomHandler && [sharedHandler.sharedCustomHandler respondsToSelector:@selector(cancelledReviewPrompt)]){
    [sharedHandler.sharedCustomHandler cancelledReviewPrompt];
  }else{
    dispatchBlock();
  }
}

+(void) willDisplayReviewPrompt:(void (^)(void))dispatchBlock ;
{
  if (sharedHandler.sharedCustomHandler && [sharedHandler.sharedCustomHandler respondsToSelector:@selector(willDisplayReviewPrompt)]){
    [sharedHandler.sharedCustomHandler willDisplayReviewPrompt];
  }else{
    dispatchBlock();
  }
}

+(void) rateUsActionCompletionHandler:(JRateUsAction)action{
  if (sharedHandler.sharedCustomHandler && [sharedHandler.sharedCustomHandler respondsToSelector:@selector(rateUsActionCompletionHandler:)]){
    [sharedHandler.sharedCustomHandler rateUsActionCompletionHandler:action];
  }else{
      
    if (action == JRateUsActionSendFeedback){
        [APRateUs takeToFeedbackScreen];
    }
    if (action == JRateUsActionRateOnStore){
      [APRateUs takeToAppStoreReviewScreen];
    }
    
  }
}

@end
