// To parse this JSON:
//
//   NSError *error;
//   SRModel *model = [SRModel fromJSON:json encoding:NSUTF8Encoding error:&error];

#import <Foundation/Foundation.h>

@class SRModel;
@class SRCriterion;
@class SREventconf;
@class SREvent;
@class SRScreenconf;
@class SRScreen;
@class SRSession;
@class SRSessionduration;

NS_ASSUME_NONNULL_BEGIN

#pragma mark - Object interfaces

@interface SRModel : NSObject
@property (nonatomic, copy) NSArray<SRCriterion *> *criteria;

+ (_Nullable instancetype)fromJSON:(NSString *)json encoding:(NSStringEncoding)encoding error:(NSError *_Nullable *)error;
+ (_Nullable instancetype)fromData:(NSData *)data error:(NSError *_Nullable *)error;
- (NSString *_Nullable)toJSON:(NSStringEncoding)encoding error:(NSError *_Nullable *)error;
- (NSData *_Nullable)toData:(NSError *_Nullable *)error;
@end

@interface SRCriterion : NSObject
@property (nonatomic, assign) NSInteger criteriaid;
@property (nonatomic, copy)   NSString *criterianame;
@property (nonatomic, copy)   NSArray<SREventconf *> *eventconf;
@property (nonatomic, copy)   NSArray<SRScreenconf *> *screenconf;
@property (nonatomic, strong) SRSession *session;
@end

@interface SREventconf : NSObject
@property (nonatomic, copy)   NSArray<SREvent *> *events;
@property (nonatomic, copy)   NSString *group;
@property (nonatomic, assign) NSInteger hitcount;
@end

@interface SREvent : NSObject
@property (nonatomic, assign) NSInteger eventstatus;
@property (nonatomic, assign) NSInteger identifier;
@property (nonatomic, copy)   NSString *name;
@end

@interface SRScreenconf : NSObject
@property (nonatomic, assign) NSInteger hitcount;
@property (nonatomic, copy)   NSArray<SRScreen *> *screens;
@end

@interface SRScreen : NSObject
@property (nonatomic, assign) NSInteger identifier;
@property (nonatomic, copy)   NSString *name;
@end

@interface SRSession : NSObject
@property (nonatomic, assign) NSInteger hitcount;
@property (nonatomic, strong) SRSessionduration *sessionduration;
@end

@interface SRSessionduration : NSObject
@property (nonatomic, assign) NSInteger max;
@property (nonatomic, assign) NSInteger min;
@end

NS_ASSUME_NONNULL_END
