/// Enums to represent in-app ratings pop-up engagements.
enum PopupAction {
  /// To represent Rate action click.
  RATE_IN_STORE_CLICKED,

  /// To represent Feedback action click.
  SEND_FEEDBACK_CLICKED,

  /// To represent later action click.
  LATER_CLICKED,
}

extension PopupActionExtension on PopupAction {
  int get value {
    switch (this) {
      case PopupAction.RATE_IN_STORE_CLICKED:
        return 1;
      case PopupAction.SEND_FEEDBACK_CLICKED:
        return 0;
      case PopupAction.LATER_CLICKED:
        return -1;
    }
  }
}